import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class starpix extends PApplet {

/* CE TRUC ce truc peut \u00eatre une sorte de jeu
  de voyage spatial : 
  les particules jaunes repr\u00e9sentent le vaisseau
  qui avance vers une lumi\u00e8re blanche, un champ
  d'\u00e9toiles.
  Des projectiles peuvent arriver sur lui et il
  peut les \u00e9viter style Space Harrier ou quelque
  chose.
  Il faut limiter la vitesse du vaisseau.
  On peut \u00e9voquer plus facilement le vaisseau qui
  avance avec un plan d'intro o\u00f9 on le verrait
  avancer de profil.
  La pixellisation pourrait s'agraver \u00e0 mesure
  qu'on approche de l'objectif.
  La musique du jeu est : Moto, de Roland Bocquet
*/



Minim minim;
AudioPlayer music;

int blockSize = 6;
int rectColor;
int noCrashX, noCrashY;
float angle;
float x, y;
float direction;
int counter;
boolean firstRun = false;

Star[] starsW;
Star[] starsY;
int maxStars = 600;

public void setup() {
  size(640,480);
  frameRate(60);
  noStroke();
  noCursor();
  starsW = new Star[maxStars];
  starsY = new Star[maxStars];

  noCrashX = width%blockSize;
  noCrashY = height%blockSize;
  
  minim = new Minim(this);
  music = minim.loadFile("moto.mp3",2048);
  music.play();
}

public void pixelate() {
  loadPixels();  
  for (int j = 0; j < height-noCrashY; j += blockSize) {
    for (int i = 0; i < width-noCrashX; i += blockSize) {
      rectColor = pixels[j*width + i];
      for (int l = 0; l < blockSize; l++) {
        for (int k = 0; k < blockSize; k++) {
          pixels[(j*width+k*width)+(i+l)] = rectColor;
        }
      }
    }
  }
  updatePixels();
}

public void draw() {
  background(0);
  angle += 0.01f;

  starsW[counter] = new Star(width/2,height/2,random(360),1.2f,color(255));
  starsY[counter] = new Star(mouseX,mouseY,random(360),1,color(255,255,200));

  if (firstRun == false) {
    for (int i = 0; i < counter; i++) {
      starsW[i].move();
      starsW[i].display();
      starsY[i].move();
      starsY[i].display();
    }
  }
  else {
    for (int i = 0; i < maxStars; i++) {
      starsW[i].move();
      starsW[i].display();
      starsY[i].move();
      starsY[i].display();
    }
  }

  pixelate();
  pixelPulse(angle,8,2);
  correctBorder();

  counter++;
  if (counter > maxStars-1) {
    counter = 0;
    firstRun = true;
  }
}

public void pixelPulse(float angle, int initialBlock, float amplitude) {
  blockSize = PApplet.parseInt(initialBlock + sin(angle)*amplitude);
  if (blockSize != 0) {
    noCrashX = width%blockSize;
    noCrashY = height%blockSize;
  }
}

public void correctBorder() {
  fill(0,0,0);
  rect(width-noCrashX,0,noCrashX,height);
  rect(0,height-noCrashY,width,noCrashY);
}

class Star {
  float x;
  float y;
  float direction;
  float speed;
  int couleur;

  Star(float t_x, float t_y, float t_direction, float t_speed, int t_couleur) {
    x = t_x;
    y = t_y;
    direction = t_direction;
    speed = t_speed;
    couleur = t_couleur;
  }

  public void display() {
    fill(couleur);
    noStroke();
    rect(x, y, 10, 10);
  }

  public void move() {
    x += cos(direction)*speed;
    y += sin(direction)*speed;
  }
}

public void stop()
{
  music.close();
  minim.stop();
  
  super.stop();
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "starpix" });
  }
}
