/* CE TRUC ce truc peut être une sorte de jeu
  de voyage spatial : 
  les particules jaunes représentent le vaisseau
  qui avance vers une lumière blanche, un champ
  d'étoiles.
  Des projectiles peuvent arriver sur lui et il
  peut les éviter style Space Harrier ou quelque
  chose.
  Il faut limiter la vitesse du vaisseau.
  On peut évoquer plus facilement le vaisseau qui
  avance avec un plan d'intro où on le verrait
  avancer de profil.
  La pixellisation pourrait s'agraver à mesure
  qu'on approche de l'objectif.
  La musique du jeu est : Moto, de Roland Bocquet
*/

import ddf.minim.*;

Minim minim;
AudioPlayer music;

int blockSize = 6;
color rectColor;
int noCrashX, noCrashY;
float angle;
float x, y;
float direction;
int counter;
boolean firstRun = false;

Star[] starsW;
Star[] starsY;
int maxStars = 600;

void setup() {
  size(640,480);
  frameRate(60);
  noStroke();
  noCursor();
  starsW = new Star[maxStars];
  starsY = new Star[maxStars];

  noCrashX = width%blockSize;
  noCrashY = height%blockSize;
  
  minim = new Minim(this);
  music = minim.loadFile("moto.mp3",2048);
  music.play();
}

void pixelate() {
  loadPixels();  
  for (int j = 0; j < height-noCrashY; j += blockSize) {
    for (int i = 0; i < width-noCrashX; i += blockSize) {
      rectColor = pixels[j*width + i];
      for (int l = 0; l < blockSize; l++) {
        for (int k = 0; k < blockSize; k++) {
          pixels[(j*width+k*width)+(i+l)] = rectColor;
        }
      }
    }
  }
  updatePixels();
}

void draw() {
  background(0);
  angle += 0.01;

  starsW[counter] = new Star(width/2,height/2,random(360),1.2,color(255));
  starsY[counter] = new Star(mouseX,mouseY,random(360),1,color(255,255,200));

  if (firstRun == false) {
    for (int i = 0; i < counter; i++) {
      starsW[i].move();
      starsW[i].display();
      starsY[i].move();
      starsY[i].display();
    }
  }
  else {
    for (int i = 0; i < maxStars; i++) {
      starsW[i].move();
      starsW[i].display();
      starsY[i].move();
      starsY[i].display();
    }
  }

  pixelate();
  pixelPulse(angle,8,2);
  correctBorder();

  counter++;
  if (counter > maxStars-1) {
    counter = 0;
    firstRun = true;
  }
}

void pixelPulse(float angle, int initialBlock, float amplitude) {
  blockSize = int(initialBlock + sin(angle)*amplitude);
  if (blockSize != 0) {
    noCrashX = width%blockSize;
    noCrashY = height%blockSize;
  }
}

void correctBorder() {
  fill(0,0,0);
  rect(width-noCrashX,0,noCrashX,height);
  rect(0,height-noCrashY,width,noCrashY);
}

class Star {
  float x;
  float y;
  float direction;
  float speed;
  color couleur;

  Star(float t_x, float t_y, float t_direction, float t_speed, color t_couleur) {
    x = t_x;
    y = t_y;
    direction = t_direction;
    speed = t_speed;
    couleur = t_couleur;
  }

  void display() {
    fill(couleur);
    noStroke();
    rect(x, y, 10, 10);
  }

  void move() {
    x += cos(direction)*speed;
    y += sin(direction)*speed;
  }
}

void stop()
{
  music.close();
  minim.stop();
  
  super.stop();
}
